diff --git a/usr.bin/btsockstat/btsockstat.c b/usr.bin/btsockstat/btsockstat.c
new file mode 100644
index 0000000000..2e1ae8fc0f
--- /dev/null
+++ b/usr.bin/btsockstat/btsockstat.c
@@ -0,0 +1,646 @@
+/*
+ * btsockstat.c
+ *
+ * Copyright (c) 2001-2002 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: btsockstat.c,v 1.8 2003/05/21 22:40:25 max Exp $
+ * $FreeBSD: head/usr.bin/bluetooth/btsockstat/btsockstat.c 180964 2008-07-29 17:02:00Z emax $
+ */
+
+#define _KERNEL_STRUCTURES
+#include <sys/types.h>
+#include <sys/callout.h>
+#include <sys/param.h>
+#include <sys/protosw.h>
+#include <sys/queue.h>
+#include <sys/socket.h>
+#include <sys/socketvar.h>
+
+#include <net/if.h>
+#include <net/if_var.h>
+
+#include <bluetooth.h>
+#include <err.h>
+#include <fcntl.h>
+#include <kvm.h>
+#include <limits.h>
+#include <nlist.h>
+
+#include <netgraph7/bluetooth/include/ng_bluetooth.h>
+#include <netgraph7/bluetooth/include/ng_btsocket_hci_raw.h>
+#include <netgraph7/bluetooth/include/ng_btsocket_l2cap.h>
+#include <netgraph7/bluetooth/include/ng_btsocket_rfcomm.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+static void	hcirawpr   (kvm_t *kvmd, u_long addr);
+static void	l2caprawpr (kvm_t *kvmd, u_long addr);
+static void	l2cappr    (kvm_t *kvmd, u_long addr);
+static void	l2caprtpr  (kvm_t *kvmd, u_long addr);
+static void	rfcommpr   (kvm_t *kvmd, u_long addr);
+static void	rfcommpr_s (kvm_t *kvmd, u_long addr);
+
+static char *	bdaddrpr   (bdaddr_p const ba, char *str, int len);
+
+static kvm_t *	kopen      (char const *memf);
+static int	kread      (kvm_t *kvmd, u_long addr, char *buffer, int size);
+
+static void	usage      (void);
+
+/*
+ * List of symbols
+ */
+
+static struct nlist	nl[] = {
+#define N_HCI_RAW	0
+	{ "_ng_btsocket_hci_raw_sockets" },
+#define N_L2CAP_RAW	1
+	{ "_ng_btsocket_l2cap_raw_sockets" },
+#define N_L2CAP		2
+	{ "_ng_btsocket_l2cap_sockets" },
+#define N_L2CAP_RAW_RT	3
+	{ "_ng_btsocket_l2cap_raw_rt" },
+#define N_L2CAP_RT	4
+	{ "_ng_btsocket_l2cap_rt" },
+#define N_RFCOMM	5
+	{ "_ng_btsocket_rfcomm_sockets" },
+#define N_RFCOMM_S	6
+	{ "_ng_btsocket_rfcomm_sessions" },
+	{ "" },
+};
+
+#define state2str(x) \
+	(((x) >= sizeof(states)/sizeof(states[0]))? "UNKNOWN" : states[(x)])
+
+/*
+ * Main
+ */
+
+static int	numeric_bdaddr = 0;
+
+int
+main(int argc, char *argv[])
+{
+	int	 opt, proto = -1, route = 0;
+	kvm_t	*kvmd = NULL;
+	char	*memf = NULL;
+
+	while ((opt = getopt(argc, argv, "hnM:p:r")) != -1) {
+		switch (opt) {
+		case 'n':
+			numeric_bdaddr = 1;
+			break;
+
+		case 'M':
+			memf = optarg;
+			break;
+
+		case 'p':
+			if (strcasecmp(optarg, "hci_raw") == 0)
+				proto = N_HCI_RAW;
+			else if (strcasecmp(optarg, "l2cap_raw") == 0)
+				proto = N_L2CAP_RAW;
+			else if (strcasecmp(optarg, "l2cap") == 0)
+				proto = N_L2CAP;
+			else if (strcasecmp(optarg, "rfcomm") == 0)
+				proto = N_RFCOMM;
+			else if (strcasecmp(optarg, "rfcomm_s") == 0)
+				proto = N_RFCOMM_S; 
+			else
+				usage();
+				/* NOT REACHED */
+			break;
+
+		case 'r':
+			route = 1;
+			break;
+
+		case 'h':
+		default:
+			usage();
+			/* NOT REACHED */
+		}
+	}
+
+	if ((proto == N_HCI_RAW || proto == N_RFCOMM || proto == N_RFCOMM_S) && route)
+		usage();
+		/* NOT REACHED */
+
+	/*
+	 * Discard setgid privileges if not the running kernel so that
+	 * bad guys can't print interesting stuff from kernel memory.
+	 */
+
+	if (memf != NULL)
+		setgid(getgid());
+
+	kvmd = kopen(memf);
+	if (kvmd == NULL)
+		return (1);
+
+	switch (proto) {
+	case N_HCI_RAW:
+		hcirawpr(kvmd, nl[N_HCI_RAW].n_value);
+		break;
+
+	case N_L2CAP_RAW:
+		if (route)
+			l2caprtpr(kvmd, nl[N_L2CAP_RAW_RT].n_value);
+		else
+			l2caprawpr(kvmd, nl[N_L2CAP_RAW].n_value);
+		break;
+
+	case N_L2CAP:
+		if (route) 
+			l2caprtpr(kvmd, nl[N_L2CAP_RT].n_value);
+		else
+			l2cappr(kvmd, nl[N_L2CAP].n_value);
+		break;
+
+	case N_RFCOMM:
+		rfcommpr(kvmd, nl[N_RFCOMM].n_value);
+		break;
+
+	case N_RFCOMM_S:
+		rfcommpr_s(kvmd, nl[N_RFCOMM_S].n_value);
+		break;
+
+	default:
+		if (route) {
+			l2caprtpr(kvmd, nl[N_L2CAP_RAW_RT].n_value);
+			l2caprtpr(kvmd, nl[N_L2CAP_RT].n_value);
+		} else {
+			hcirawpr(kvmd, nl[N_HCI_RAW].n_value);
+			l2caprawpr(kvmd, nl[N_L2CAP_RAW].n_value);
+			l2cappr(kvmd, nl[N_L2CAP].n_value);
+			rfcommpr_s(kvmd, nl[N_RFCOMM_S].n_value);
+			rfcommpr(kvmd, nl[N_RFCOMM].n_value);
+		}
+		break;
+	}
+
+	return (kvm_close(kvmd));
+} /* main */
+
+/*
+ * Print raw HCI sockets
+ */
+
+static void
+hcirawpr(kvm_t *kvmd, u_long addr)
+{
+	ng_btsocket_hci_raw_pcb_p	this = NULL, next = NULL;
+	ng_btsocket_hci_raw_pcb_t	pcb;
+	struct socket			so;
+	int				first = 1;
+
+	if (addr == 0)
+		return;
+
+        if (kread(kvmd, addr, (char *) &this, sizeof(this)) < 0)
+		return;
+
+	for ( ; this != NULL; this = next) {
+		if (kread(kvmd, (u_long) this, (char *) &pcb, sizeof(pcb)) < 0)
+			return;
+		if (kread(kvmd, (u_long) pcb.so, (char *) &so, sizeof(so)) < 0)
+			return;
+
+		next = LIST_NEXT(&pcb, next);
+
+		if (first) {
+			first = 0;
+			fprintf(stdout,
+"Active raw HCI sockets\n" \
+"%-8.8s %-8.8s %-6.6s %-6.6s %-6.6s %-16.16s\n",
+				"Socket",
+				"PCB",
+				"Flags",
+				"Recv-Q",
+				"Send-Q",
+				"Local address");
+		}
+
+		if (pcb.addr.hci_node[0] == 0) {
+			pcb.addr.hci_node[0] = '*';
+			pcb.addr.hci_node[1] = 0;
+		}
+
+		fprintf(stdout,
+"%-8lx %-8lx %-6.6x %6lu %6lu %-16.16s\n",
+			(unsigned long) pcb.so,
+			(unsigned long) this,
+			pcb.flags,
+			so.so_rcv.sb.sb_cc,
+			so.so_snd.sb.sb_cc,
+			pcb.addr.hci_node);
+	}
+} /* hcirawpr */
+
+/*
+ * Print raw L2CAP sockets
+ */
+
+static void
+l2caprawpr(kvm_t *kvmd, u_long addr)
+{
+	ng_btsocket_l2cap_raw_pcb_p	this = NULL, next = NULL;
+	ng_btsocket_l2cap_raw_pcb_t	pcb;
+	struct socket			so;
+	int				first = 1;
+
+	if (addr == 0)
+		return;
+
+        if (kread(kvmd, addr, (char *) &this, sizeof(this)) < 0)
+		return;
+
+	for ( ; this != NULL; this = next) {
+		if (kread(kvmd, (u_long) this, (char *) &pcb, sizeof(pcb)) < 0)
+			return;
+		if (kread(kvmd, (u_long) pcb.so, (char *) &so, sizeof(so)) < 0)
+			return;
+
+		next = LIST_NEXT(&pcb, next);
+
+		if (first) {
+			first = 0;
+			fprintf(stdout, 
+"Active raw L2CAP sockets\n" \
+"%-8.8s %-8.8s %-6.6s %-6.6s %-17.17s\n",
+				"Socket",
+				"PCB",
+				"Recv-Q",
+				"Send-Q",
+				"Local address");
+		}
+
+		fprintf(stdout,
+"%-8lx %-8lx %6lu %6lu %-17.17s\n",
+			(unsigned long) pcb.so,
+			(unsigned long) this,
+			so.so_rcv.sb.sb_cc,
+			so.so_snd.sb.sb_cc,
+			bdaddrpr(&pcb.src, NULL, 0));
+	}
+} /* l2caprawpr */
+
+/*
+ * Print L2CAP sockets
+ */
+
+static void
+l2cappr(kvm_t *kvmd, u_long addr)
+{
+	static char const * const	states[] = {
+	/* NG_BTSOCKET_L2CAP_CLOSED */		"CLOSED",
+	/* NG_BTSOCKET_L2CAP_CONNECTING */	"CON",
+	/* NG_BTSOCKET_L2CAP_CONFIGURING */	"CONFIG",
+	/* NG_BTSOCKET_L2CAP_OPEN */		"OPEN",
+	/* NG_BTSOCKET_L2CAP_DISCONNECTING */	"DISCON"
+	};
+
+	ng_btsocket_l2cap_pcb_p	this = NULL, next = NULL;
+	ng_btsocket_l2cap_pcb_t	pcb;
+	struct socket		so;
+	int			first = 1;
+	char			local[24], remote[24];
+
+	if (addr == 0)
+		return;
+
+        if (kread(kvmd, addr, (char *) &this, sizeof(this)) < 0)
+		return;
+
+	for ( ; this != NULL; this = next) {
+		if (kread(kvmd, (u_long) this, (char *) &pcb, sizeof(pcb)) < 0)
+			return;
+		if (kread(kvmd, (u_long) pcb.so, (char *) &so, sizeof(so)) < 0)
+			return;
+
+		next = LIST_NEXT(&pcb, next);
+
+		if (first) {
+			first = 0;
+			fprintf(stdout,
+"Active L2CAP sockets\n" \
+"%-8.8s %-6.6s %-6.6s %-23.23s %-17.17s %-5.5s %s\n",
+				"PCB",
+				"Recv-Q",
+				"Send-Q",
+				"Local address/PSM",
+				"Foreign address",
+				"CID",
+				"State");
+		}
+
+		fprintf(stdout,
+"%-8lx %6lu %6lu %-17.17s/%-5d %-17.17s %-5d %s\n",
+			(unsigned long) this,
+			so.so_rcv.sb.sb_cc,
+			so.so_snd.sb.sb_cc,
+			bdaddrpr(&pcb.src, local, sizeof(local)),
+			pcb.psm,
+			bdaddrpr(&pcb.dst, remote, sizeof(remote)),
+			pcb.cid,
+			(so.so_options & SO_ACCEPTCONN)?
+				"LISTEN" : state2str(pcb.state));
+	}
+} /* l2cappr */
+
+/*
+ * Print L2CAP routing table
+ */
+
+static void
+l2caprtpr(kvm_t *kvmd, u_long addr)
+{
+	ng_btsocket_l2cap_rtentry_p	this = NULL, next = NULL;
+	ng_btsocket_l2cap_rtentry_t	rt;
+	int				first = 1;
+
+	if (addr == 0)
+		return;
+
+	if (kread(kvmd, addr, (char *) &this, sizeof(this)) < 0)
+		return;
+
+	for ( ; this != NULL; this = next) {
+		if (kread(kvmd, (u_long) this, (char *) &rt, sizeof(rt)) < 0)
+			return;
+
+		next = LIST_NEXT(&rt, next);
+
+		if (first) {
+			first = 0;
+			fprintf(stdout,
+"Known %sL2CAP routes\n", (addr == nl[N_L2CAP_RAW_RT].n_value)?  "raw " : "");
+			fprintf(stdout,
+"%-8.8s %-8.8s %-17.17s\n",	"RTentry",
+				"Hook",
+				"BD_ADDR");
+		}
+
+		fprintf(stdout,
+"%-8lx %-8lx %-17.17s\n",
+			(unsigned long) this,
+			(unsigned long) rt.hook,
+			bdaddrpr(&rt.src, NULL, 0));
+	}
+} /* l2caprtpr */
+
+/*
+ * Print RFCOMM sockets
+ */
+
+static void
+rfcommpr(kvm_t *kvmd, u_long addr)
+{
+	static char const * const	states[] = {
+	/* NG_BTSOCKET_RFCOMM_DLC_CLOSED */	   "CLOSED",
+	/* NG_BTSOCKET_RFCOMM_DLC_W4_CONNECT */	   "W4CON",
+	/* NG_BTSOCKET_RFCOMM_DLC_CONFIGURING */   "CONFIG",
+	/* NG_BTSOCKET_RFCOMM_DLC_CONNECTING */    "CONN",
+	/* NG_BTSOCKET_RFCOMM_DLC_CONNECTED */     "OPEN",
+	/* NG_BTSOCKET_RFCOMM_DLC_DISCONNECTING */ "DISCON"
+	};
+
+	ng_btsocket_rfcomm_pcb_p	this = NULL, next = NULL;
+	ng_btsocket_rfcomm_pcb_t	pcb;
+	struct socket			so;
+	int				first = 1;
+	char				local[24], remote[24];
+
+	if (addr == 0)
+		return;
+
+        if (kread(kvmd, addr, (char *) &this, sizeof(this)) < 0)
+		return;
+
+	for ( ; this != NULL; this = next) {
+		if (kread(kvmd, (u_long) this, (char *) &pcb, sizeof(pcb)) < 0)
+			return;
+		if (kread(kvmd, (u_long) pcb.so, (char *) &so, sizeof(so)) < 0)
+			return;
+
+		next = LIST_NEXT(&pcb, next);
+
+		if (first) {
+			first = 0;
+			fprintf(stdout,
+"Active RFCOMM sockets\n" \
+"%-8.8s %-6.6s %-6.6s %-17.17s %-17.17s %-4.4s %-4.4s %s\n",
+				"PCB",
+				"Recv-Q",
+				"Send-Q",
+				"Local address",
+				"Foreign address",
+				"Chan",
+				"DLCI",
+				"State");
+		}
+
+		fprintf(stdout,
+"%-8lx %6lu %6lu %-17.17s %-17.17s %-4d %-4d %s\n",
+			(unsigned long) this,
+			so.so_rcv.sb.sb_cc,
+			so.so_snd.sb.sb_cc,
+			bdaddrpr(&pcb.src, local, sizeof(local)),
+			bdaddrpr(&pcb.dst, remote, sizeof(remote)),
+			pcb.channel,
+			pcb.dlci,
+			(so.so_options & SO_ACCEPTCONN)?
+				"LISTEN" : state2str(pcb.state));
+	}
+} /* rfcommpr */
+
+/*
+ * Print RFCOMM sessions
+ */
+
+static void
+rfcommpr_s(kvm_t *kvmd, u_long addr)
+{
+	static char const * const	states[] = {
+	/* NG_BTSOCKET_RFCOMM_SESSION_CLOSED */	       "CLOSED",
+	/* NG_BTSOCKET_RFCOMM_SESSION_LISTENING */     "LISTEN",
+	/* NG_BTSOCKET_RFCOMM_SESSION_CONNECTING */    "CONNECTING",
+	/* NG_BTSOCKET_RFCOMM_SESSION_CONNECTED */     "CONNECTED",
+	/* NG_BTSOCKET_RFCOMM_SESSION_OPEN */          "OPEN",
+	/* NG_BTSOCKET_RFCOMM_SESSION_DISCONNECTING */ "DISCONNECTING"
+	};
+
+	ng_btsocket_rfcomm_session_p	this = NULL, next = NULL;
+	ng_btsocket_rfcomm_session_t	s;
+	struct socket			so;
+	int				first = 1;
+
+	if (addr == 0)
+		return;
+
+        if (kread(kvmd, addr, (char *) &this, sizeof(this)) < 0)
+		return;
+
+	for ( ; this != NULL; this = next) {
+		if (kread(kvmd, (u_long) this, (char *) &s, sizeof(s)) < 0)
+			return;
+		if (kread(kvmd, (u_long) s.l2so, (char *) &so, sizeof(so)) < 0)
+			return;
+
+		next = LIST_NEXT(&s, next);
+
+		if (first) {
+			first = 0;
+			fprintf(stdout,
+"Active RFCOMM sessions\n" \
+"%-8.8s %-8.8s %-4.4s %-5.5s %-5.5s %-4.4s %s\n",
+				"L2PCB",
+				"PCB",
+				"Flags",
+				"MTU",
+				"Out-Q",
+				"DLCs",
+				"State");
+		}
+
+		fprintf(stdout,
+"%-8lx %-8lx %-4x %-5d %-5d %-4s %s\n",
+			(unsigned long) so.so_pcb,
+			(unsigned long) this,
+			s.flags,
+			s.mtu,
+			s.outq.len,
+			LIST_EMPTY(&s.dlcs)? "No" : "Yes",
+			state2str(s.state));
+	}
+} /* rfcommpr_s */
+
+/*
+ * Return BD_ADDR as string
+ */
+
+static char *
+bdaddrpr(bdaddr_p const ba, char *str, int len)
+{
+	static char	 buffer[MAXHOSTNAMELEN];
+	struct hostent	*he = NULL;
+
+	if (str == NULL) {
+		str = buffer;
+		len = sizeof(buffer);
+	}
+
+	if (memcmp(ba, NG_HCI_BDADDR_ANY, sizeof(*ba)) == 0) {
+		str[0] = '*';
+		str[1] = 0;
+
+		return (str);
+	}
+
+	if (!numeric_bdaddr &&
+	    (he = bt_gethostbyaddr((char *)ba, sizeof(*ba), AF_BLUETOOTH)) != NULL) {
+		strlcpy(str, he->h_name, len);
+
+		return (str);
+	}
+
+	bt_ntoa(ba, str);
+
+	return (str);
+} /* bdaddrpr */
+
+/*
+ * Open kvm
+ */
+
+static kvm_t *
+kopen(char const *memf)
+{
+	kvm_t	*kvmd = NULL;
+	char	 errbuf[_POSIX2_LINE_MAX];
+
+	/*
+	 * Discard setgid privileges if not the running kernel so that 
+	 * bad guys can't print interesting stuff from kernel memory.
+	 */
+
+	if (memf != NULL)
+		setgid(getgid());   
+
+	kvmd = kvm_openfiles(NULL, memf, NULL, O_RDONLY, errbuf);
+	if (kvmd == NULL) {
+		warnx("kvm_openfiles: %s", errbuf);
+		return (NULL);
+	}
+
+	if (kvm_nlist(kvmd, nl) < 0) {
+		warnx("kvm_nlist: %s", kvm_geterr(kvmd));
+		goto fail;
+	}
+
+	if (nl[0].n_type == 0) {
+		warnx("kvm_nlist: no namelist");
+		goto fail;
+	}
+
+	return (kvmd);
+fail:
+	kvm_close(kvmd);
+
+	return (NULL);
+} /* kopen */
+
+/*
+ * Read kvm
+ */
+
+static int
+kread(kvm_t *kvmd, u_long addr, char *buffer, int size)
+{
+	if (kvmd == NULL || buffer == NULL)
+		return (-1);
+
+	if (kvm_read(kvmd, addr, buffer, size) != size) {
+		warnx("kvm_read: %s", kvm_geterr(kvmd));
+		return (-1);
+	}
+
+	return (0);
+} /* kread */
+
+/*
+ * Print usage and exit
+ */
+
+static void
+usage(void)
+{
+	fprintf(stdout, "Usage: btsockstat [-M core ] [-n] [-p proto] [-r]\n");
+	exit(255);
+} /* usage */
+
diff --git a/usr.bin/rfcomm_sppd/Makefile b/usr.bin/rfcomm_sppd/Makefile
index 79357e15cf..fbd15119e7 100644
--- a/usr.bin/rfcomm_sppd/Makefile
+++ b/usr.bin/rfcomm_sppd/Makefile
@@ -1,11 +1,11 @@
-# $NetBSD: Makefile,v 1.2 2007/05/28 12:06:29 tls Exp $
-# $DragonFly: src/usr.bin/rfcomm_sppd/Makefile,v 1.1 2008/02/08 14:06:25 hasso Exp $
+# $Id: Makefile,v 1.7 2003/09/07 18:15:55 max Exp $
+# $FreeBSD: head/usr.bin/bluetooth/rfcomm_sppd/Makefile 140941 2005-01-28 16:08:11Z ru $
 
 PROG=		rfcomm_sppd
 SRCS=		rfcomm_sppd.c rfcomm_sdp.c
+WARNS?=		2
 
-CFLAGS+=	-I${.CURDIR}/../../sys
-DPADD+=		${LIBBLUETOOTH} ${LIBSDP}
-LDADD+=		-lbluetooth -lsdp
+DPADD=		${LIBBLUETOOTH} ${LIBSDP}
+LDADD=		-lbluetooth -lsdp
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/rfcomm_sppd/rfcomm_sdp.c b/usr.bin/rfcomm_sppd/rfcomm_sdp.c
index 6a3834b3d8..1b61ea9e20 100644
--- a/usr.bin/rfcomm_sppd/rfcomm_sdp.c
+++ b/usr.bin/rfcomm_sppd/rfcomm_sdp.c
@@ -1,34 +1,3 @@
-/* $NetBSD: rfcomm_sdp.c,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.bin/rfcomm_sppd/rfcomm_sdp.c,v 1.1 2008/02/08 14:06:25 hasso Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * rfcomm_sdp.c
  *
@@ -56,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: rfcomm_sdp.c,v 1.1 2006/06/19 15:44:56 gdamore Exp $
- * $FreeBSD: src/usr.bin/bluetooth/rfcomm_sppd/rfcomm_sdp.c,v 1.2 2004/04/09 23:26:16 emax Exp $
+ * $Id: rfcomm_sdp.c,v 1.1 2003/09/07 18:15:55 max Exp $
+ * $FreeBSD: head/usr.bin/bluetooth/rfcomm_sppd/rfcomm_sdp.c 128077 2004-04-09 23:26:16Z emax $
  */
 
 #include <bluetooth.h>
@@ -65,8 +34,6 @@
 #include <sdp.h>
 #include <stdio.h>
 
-#include "rfcomm_sdp.h"
-
 #undef	PROTOCOL_DESCRIPTOR_LIST_BUFFER_SIZE
 #define	PROTOCOL_DESCRIPTOR_LIST_BUFFER_SIZE	256
 
@@ -74,7 +41,7 @@
 #define	PROTOCOL_DESCRIPTOR_LIST_MINIMAL_SIZE	12
 
 static int rfcomm_proto_list_parse (uint8_t const *start, uint8_t const *end,
-					uint8_t *channel, int *error);
+					int *channel, int *error);
 
 /*
  * Lookup RFCOMM channel number in the Protocol Descriptor List
@@ -93,7 +60,7 @@ static int rfcomm_proto_list_parse (uint8_t const *start, uint8_t const *end,
 
 int
 rfcomm_channel_lookup(bdaddr_t const *local, bdaddr_t const *remote,
-			int service, uint8_t *channel, int *error)
+			int service, int *channel, int *error)
 {
 	uint8_t		 buffer[PROTOCOL_DESCRIPTOR_LIST_BUFFER_SIZE];
 	void		*ss    = NULL;
@@ -105,7 +72,7 @@ rfcomm_channel_lookup(bdaddr_t const *local, bdaddr_t const *remote,
 	uint32_t	 type, len;
 
 	if (local == NULL)
-		local = BDADDR_ANY;
+		local = NG_HCI_BDADDR_ANY;
 	if (remote == NULL || channel == NULL)
 		rfcomm_channel_lookup_exit(EINVAL);
 
@@ -123,7 +90,7 @@ rfcomm_channel_lookup(bdaddr_t const *local, bdaddr_t const *remote,
 	ss = NULL;
 
 	/*
-	 * If it is possible for more than one kind of protocol stack to be
+	 * If it is possible for more than one kind of protocol stack to be 
 	 * used to gain access to the service, the ProtocolDescriptorList
 	 * takes the form of a data element alternative. We always use the
 	 * first protocol stack.
@@ -136,11 +103,11 @@ rfcomm_channel_lookup(bdaddr_t const *local, bdaddr_t const *remote,
 	 *		uuid16 value16	- 3 bytes	L2CAP
 	 *	seq8 len8		- 2 bytes
 	 *		uuid16 value16	- 3 bytes	RFCOMM
-	 *		uint8  value8	- 2 bytes	RFCOMM param #1
+	 *		uint8  value8	- 2 bytes	RFCOMM param #1 
 	 *				=========
 	 *				 14 bytes
 	 *
-	 * Lets not count first [seq8 len8] wrapper, so the minimal size of
+	 * Lets not count first [seq8 len8] wrapper, so the minimal size of 
 	 * the Protocol Descriptor List (the data we are actually interested
 	 * in) for RFCOMM based service would be 12 bytes.
 	 */
@@ -186,14 +153,14 @@ rfcomm_channel_lookup(bdaddr_t const *local, bdaddr_t const *remote,
 	return (rfcomm_proto_list_parse(proto.value,
 					buffer + proto.vlen, channel, error));
 }
-
+	
 /*
  * Parse protocol descriptor list
  *
  * The ProtocolDescriptorList attribute describes one or more protocol
- * stacks that may be used to gain access to the service described by
+ * stacks that may be used to gain access to the service described by 
  * the service record. If the ProtocolDescriptorList describes a single
- * stack, it takes the form of a data element sequence in which each
+ * stack, it takes the form of a data element sequence in which each 
  * element of the sequence is a protocol descriptor.
  */
 
@@ -206,21 +173,21 @@ rfcomm_channel_lookup(bdaddr_t const *local, bdaddr_t const *remote,
 
 static int
 rfcomm_proto_list_parse(uint8_t const *start, uint8_t const *end,
-			uint8_t *channel, int *error)
+			int *channel, int *error)
 {
 	int	type, len, value;
 
 	while (start < end) {
 
-		/*
+		/* 
 		 * Parse protocol descriptor
 		 *
-		 * A protocol descriptor identifies a communications protocol
-		 * and provides protocol specific parameters. A protocol
-		 * descriptor is represented as a data element sequence. The
-		 * first data element in the sequence must be the UUID that
+		 * A protocol descriptor identifies a communications protocol 
+		 * and provides protocol specific parameters. A protocol 
+		 * descriptor is represented as a data element sequence. The 
+		 * first data element in the sequence must be the UUID that 
 		 * identifies the protocol. Additional data elements optionally
-		 * provide protocol specific information, such as the L2CAP
+		 * provide protocol specific information, such as the L2CAP 
 		 * protocol/service multiplexer (PSM) and the RFCOMM server
 		 * channel number (CN).
 		 */
@@ -290,9 +257,10 @@ rfcomm_proto_list_parse(uint8_t const *start, uint8_t const *end,
 	}
 
 	/*
-	 * If we got here then it means we could not find RFCOMM protocol
+	 * If we got here then it means we could not find RFCOMM protocol 
 	 * descriptor, but the reply format was actually valid.
 	 */
 
 	rfcomm_proto_list_parse_exit(ENOATTR);
 }
+
